<template>
  <div class="app app-register layout-container">
    <div class="space">
      <div class="form-block">
        <div class="name-header row m-0" v-if="user.login">
          <div class="col-12">
            {{getUserInfo.name}}
          </div>
          <div class="col-12">
            <a href="/14/api/auth/logout">
              ออกจากระบบ
              <i class="fas fa-power-off"></i>
            </a>
          </div>
        </div>
        <div class="form-header row m-0">
          <div class="col form-menu" :class="{ '': user.login, 'disable': !user.login, 'active': $route.name == 'Reg_Personal' }" v-if="!getUserProgress().submit && $route.name != 'Reg_Summary'">
            <!-- <router-link :to="{ name: 'Reg_Personal'}"> -->
              <div class="textbox row">
                <div class="col-2 text-main">
                  1
                </div>
                <div class="col text-sub">
                  <b>ข้อมูลส่วนตัว</b>
                  <span>Personal Info</span>
                </div>
              </div>
            <!-- </router-link> -->
          </div>
          <div class="col form-menu" :class="{ '': user.login, 'disable': !user.login || getUserProgress().submit, 'active': $route.name == 'Reg_Personal' }" v-else>
            <div class="textbox row">
              <div class="col-2 text-main">
                1
              </div>
              <div class="col text-sub">
                <b>ข้อมูลส่วนตัว</b>
                <span>Personal Info</span>
              </div>
            </div>
          </div>
          <div class="col form-menu" :class="{ '' : user.login, 'disable': !user.login || getUserProgress().progress < 1 || getUserProgress().submit, 'active': $route.name == 'Reg_Camp' }" v-if="getUserProgress().progress >= 1 && !getUserProgress().submit && $route.name != 'Reg_Summary'">
            <!-- <router-link :to="{ name: 'Reg_Camp'}"> -->
              <div class="textbox row">
                <div class="col-2 text-main">
                  2
                </div>
                <div class="col text-sub">
                  <b>คำถามค่าย</b>
                  <span>Camp Question</span>
                </div>
              </div>
            <!-- </router-link> -->
          </div>
          <div class="col form-menu" :class="{ '' : user.login, 'disable': !user.login || getUserProgress().progress < 2 || getUserProgress().submit, 'active': $route.name == 'Reg_Camp' }" v-else>
            <div class="textbox row">
              <div class="col-2 text-main">
                2
              </div>
              <div class="col text-sub">
                <b>คำถามค่าย</b>
                <span>Camp Question</span>
              </div>
            </div>
          </div>
          <div class="col form-menu" :class="{ '' : user.login, 'disable': !user.login || getUserProgress().progress < 2, 'active': $route.path.split('/').indexOf('subcamp') > 0 }" v-if="getUserProgress().progress >= 2 && !getUserProgress().submit &&  $route.name != 'Reg_Summary'">
            <!-- <router-link :to="{ name: forcePage }"> -->
              <div class="textbox row">
                <div class="col-2 text-main">
                  3
                </div>
                <div class="col text-sub">
                  <b>คำถามแคมป์ย่อย</b>
                  <span>Subcamp Question</span>
                </div>
              </div>
            <!-- </router-link> -->
          </div>
          <div class="col form-menu" :class="{ '' : user.login, 'disable': !user.login || getUserProgress().progress < 3 || getUserProgress().submit, 'active': $route.path.split('/').indexOf('subcamp') > 0 }" v-else>
            <div class="textbox row">
              <div class="col-2 text-main">
                3
              </div>
              <div class="col text-sub">
                <b>คำถามแคมป์ย่อย</b>
                <span>Subcamp Question</span>
              </div>
            </div>
          </div>
        </div>
        <div class="form-body">
          <transition name="fade" mode="out-in">
            <router-view/>
          </transition>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapMutations, mapActions, mapGetters } from 'vuex';
import { scrollTo } from '@js/animate';
export default {
  name: 'Register',
  data() {
    return {
      pageName: this.$route.name,
      campName: null
    };
  },
  created() {
    scrollTo('.app-register', 100);
    this.activeUserProgress();
  },
  beforeRouteUpdate(to, from, next) {
    this.activeUserProgress();
    next();
  },
  computed: {
    ...mapState(['user', 'env', 'validator', 'forcePage']),
    ...mapGetters(['getUserLogin', 'getUserInfo', 'getValidator'])
  },
  methods: {
    ...mapActions(['saveForm', 'activeUserProgress']),
    ...mapGetters(['getUserProgress']),
    scrollTo: scrollTo,
    sendSaveForm(page) {
      this.$validator.validateAll().then((result) => {
        this.saveForm(page);
      });
    }
  }
};
</script>
<style>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.3s ease;
}
.fade-enter,
.fade-leave-active {
  opacity: 0;
}
</style>
